# Посібник із Магазину додатків для NVDA
## Як використовувати

Додаток надається без призначених жестів, але надає можливість призначити їх на дві команди:

* Показує вікно з усіма додатками й інформацією про них: вам буде показано вікно з усіма додатками, які є в https://www.nvda.es

* Перевірити оновлення встановлених додатків: він проаналізує встановлені додатки і запропонує вам автоматично оновити додатки, до яких знайдено оновлення.

Ви можете призначити жести вводу для цих двох параметрів, перейшовши в меню NVDA / Налаштування / жести вводу і знайти категорію Магазин додатків NVDA.ES.

### Показати вікно з усіма додатками й інформацією про них

На цьому екрані вам відобразяться  вкладки всіх додатків з кнопками для їх завантаження.

Якщо ви оглянете вікно, ви побачите список всіх додатків, поля з обраною вкладкою додатка, кнопку «Завантажити додаток», кнопку «Відвідати веб-сайт», щоб перейти на сторінку додатка, і кнопку «Вийти».

Крім того, у вас буде вікно пошуку, в якому ви можете вписати те, що хочете знайти, і після натискання Enter, у списку відобразяться результати.

Для повернення до списку всіх додатків, вам просто потрібно повернутися в поле пошуку, видалити його вміст і натиснути Enter з порожнім полем.

У полі вкладки додатка, якщо він має більш як одну гілку розробки, також буде показано інформацію.

Кнопка з назвою «Завантажити додаток» розгорне меню з різними гілками розробки додатка, вам потрібно буде вибрати одну для завантаження. У випадку, якщо додаток має лише одну гілку, вам буде надано цей варіант.

На цьому екрані є такі гарячі клавіші для переміщення в межах інтерфейсу:

* Alt + B: перейти у вікно пошуку.
* Alt + L: перейти до списку додатків.
* Alt + I: перейти в поле вкладки, щоб переглянути інформацію про вибраний додаток.
* Alt + D: активація кнопки «Завантажити додаток».
* Alt + P: перейти на сторінку додатка.
* Alt + S, Escape, Alt + F4: закрити вікно.

#### Контекстне меню у списку додатків

У списку додатків можна відобразити контекстне меню або за допомогою кнопки Applications (контекст) на клавіатурі, або Shift + F10 для тих клавіатур, на яких немає кнопки Applications.

Це меню складається з двох підменю:

Фільтри та копіювання в буфер обміну.

У підменю «Фільтри» є такі параметри:

* Показати всі додатки: Цей параметр  використовується початково при першому запуску Магазину.

Цей параметр покаже всі додатки у базі даних.

Цей параметр також підпорядковується прапорцю «Сортувати додатки Магазину і результати пошуку за абеткою», тому якщо цей прапорець у налаштуваннях позначено, список додатків, як і результати пошуку, буде відсортовано за абеткою.

* Показувати додатки із сумісністю з API 2022: Цей параметр буде відображати лише ті додатки, які зазначені в маніфесті як сумісні з API 2022.

* Показувати додатки із сумісністю з API 2021: Цей параметр покаже лише ті додатки, які зазначені у маніфесті з цією сумісністю.

Цей параметр також підпорядковується прапорцю «Сортувати додатки Магазину і результати пошуку за абеткою», тому якщо цей прапорець у налаштуваннях позначено, список додатків, як і результати пошуку, буде відсортовано за абеткою.

Зауважте, що в цьому списку не буде додатків, автори яких у маніфесті вказали API, які ще не з'явились.

* Показувати додатки, відсортовані за автором: Цей параметр покаже список додатків, відсортований за іменами їхніх авторів.
 
* Показувати за кількістю завантажень від найвищої до найнижчої: Цей параметр покаже нам всі додатки, але відсортує їх за кількістю завантажень.

Ці параметри індивідуальні, тобто не можна позначити кілька фільтрів.
 
Кожен параметр змінюватиме заголовок вікна, інформуючи нас про те, який фільтр активний.

Параметри зберігаються при активації магазину до перезапуску NVDA. Після перезапуску додаток повернеться до початкового значення, а в списку, завантаженому вперше, активується параметр «Показати всі додатки».

За винятком параметра «Показати всі додатки», решта опцій фільтруються лише за першою гілкою розробки. Якщо додаток має більше однієї гілки, вони не враховуватимуться, крім головної гілки, щоб відфільтрувати результати у кожному варіанті.

У підменю «Копіювати в буфер обміну» є такі параметри:

* Копіювати інформацію: Якщо ви виберете цей параметр, всю вкладку обраного додатка буде скопійовано в буфер обміну.

* Копіювати посилання на сайт додатка: Якщо ви виберете цей параметр, URL офіційного сайту додатка буде скопійовано в буфер обміну.

* Копіювати посилання на завантаження додатка: Це підменю, яке міститиме гілки розробки додатка. Коли ви виберете одну, якщо у вас їх кілька, додаток скопіює URL-адресу для завантаження додатка в буфер обміну.

### Перевірити оновлення встановлених додатків

Дозволяє вам оновити ті додатки, які на https://www.nvda.es новіші, аніж у вас.

На цьому екрані ви можете вибрати додатки, які хочете оновити, якщо для них є оновлення.

Позначте відповідні додатки пробілом і натиснітть кнопку «Оновити».

На цьому екрані буде показано оновлення, яке відповідає гілці, яку ми вибрали, зайшовши в меню NVDA/Параметри/Налаштування/Магазин NVDA.ES, і там ми можемо вибрати, якщо існує кілька гілок розробки, ту, яка нам потрібна (про це буде розказано у наступному розділі).

На цьому екрані у нас є такі клавіші:

* Alt + S: вибрати всі додатки зі списку, щоб встановити всі оновлення додатків, встановлених на вашому комп'ютері.
* Alt + D: скасувати вибір всіх оновлень для всіх додатків зі списку, якщо вони були раніше позначені.
* Alt + A: почати оновлення додатків, які ви вибрали в списку.
* Alt + C, Alt + F4 або Escape: закрити вікно.

### Панель параметрів

Ви зможете налаштувати деякі аспекти поведінки Магазину, перейшовши в меню NVDA / Налаштування / Параметри і знайшовши категорію Магазин NVDA.ES.

* Увімкнути або вимкнути перевірку оновлень.

Якщо позначити цей прапорець, з'явиться поле зі списком, в якому ви зможете вибрати, скільки часу пройде між перевірками оновлень.

Початково перевірку оновлень вимкнено.

Поведінка цього параметра проста: він шукатиме оновлення на сервері в заданому часовому діапазоні, повідомить системним сповіщенням про те, скільки оновлень є і запропонує відкрити відповідний параметр в Магазині NVDA.ES.

Цей параметр вимикається автоматично після десяти перевірок з метою уникнення надмірної кількості запитів до сервера.

Таким чином, якщо ви обрали діапазон у 15 хвилин і за цей час додаток не знайде оновлень, параметр автоперевірки оновлень буде вимкнено через дві години і 30 хвилин.

У випадку, якщо є оновлення, додаток перевірить наявність оновлень ще п’ять разів у заданому часовому діапазоні, а потім автоперевірку буде вимкнено. Водночас додаток щоразу повідомлятиме про оновлення, допоки ви їх не встановите.

* Сортування додатків і результатів пошуку за абеткою.

Якщо ви позначите цей прапорець, то після відкриття Магазину вам будуть показані додатки в алфавітному порядку. Крім того, якщо ви шукаєте будь-які додатки, результати пошуку будуть відображатися також в алфавітному порядку.

* Встановлення додатків після завантаження.

Якщо ви позначите цей прапорець, то після завершення завантаження додатка майстер встановлення додатків NVDA запитає, чи хочете ви встановити додаток.

* Встановлені додатки на сервері.

В цьому списку нам будуть показані ті додатки, які у нас встановлені й розташовані на сервері.

Будуть відображатися лише ті, які підтримують поточний API NVDA.

У цьому списку ви можете вибрати, яку гілку оновлення цього додатка хочете використовувати. Якщо ви натиснете на додатку пробіл, то розгорнете всі гілки розробки для цього додатка. Ви можете вибрати ту, яку ви хочете,натиснувши Enter, і вибір буде збережено.

Попередження: зміни в списку будуть збережені тільки в тому випадку, якщо ми натиснемо кнопку «Гаразд» або «Застосувати» в діалозі налаштувань.

Цей список оновлюється щоразу, коли ви перезапускаєте NVDA, додаючи, якщо є, нові додатки, або видаляючи ті, яких більше немає.

Тому, якщо ви видалите додаток, а потім перевстановите його, вам доведеться знову вибрати бажану гілку.

Цей список як при першому створенні, так і при кожному додаванні додатка завжди буде початково ставити першу гілку розробки на сервері.

## Примітки

Під час перевірки оновлень тепер є два захисти:

1 він перевірить, чи є додатки, які потрібно видалити.

Якщо так, то ці додатки вимикаються, навіть якщо є оновлення.

2º він підтвердить, що додаток із сервера відповідає вимогам API, встановленої у вас NVDA.

Якщо ця умова не дотримується, додаток не може бути встановлений, навіть якщо версія із сервера є новішою і сервер пропонує цей додаток.

Під час встановлення також передбачено деякі засоби захисту:

1º тепер він попередить вас, якщо додаток не було оновлено, і повідомить його ім’я.

2º На цьому кроці також перевіряється, чи має додаток мінімальну версію для використання у встановленій вами  NVDA.

3º Магазин NVDA.ES  не дозволить продовжити пошук оновлень, якщо ви вже оновили один чи кілька додатків і не перезапустили NVDA.

4º Якщо ми активували опцію «Перевіряти оновлення встановлених додатків», то щоразу при пошуку та виявленні того, що ви не перезапустили NVDA, ви отримуватимете системне сповіщення.

5º Аналогічно, якщо ви спробуєте активувати опцію «Перевірити оновлення встановлених додатків» та не перезапустите NVDA, скрінрідер видасть повідомлення про те, що вам необхідно перезапустити NVDA для застосування оновлень.

6º У гіршому випадку, якщо бібліотеки не завантажаться через відсутність інтернету, вам будуть показані інформаційні повідомлення в журналі NVDA, а також, якщо ви спробуєте зайти в магазин, то будете попереджені голосовим повідомленням.

Функція, яка перевіряє наявність оновлень, була покращена, тепер вона стала набагато надійнішою, а також додала вищезазначені засоби захисту.

Було зроблено багато внутрішніх удосконалень, щоб зробити додаток надійнішим.

Цей додаток перебуває на стадії тестування, тому, будь ласка, зрозумійте, що в ньому можуть бути помилки.

Будь ласка, зв'яжіться з нами, щоб повідомити про них, щоб ми могли виправити їх якнайшвидше.

Насолоджуйтесь магазином для NVDA.ES!

## Журнал змін.
## Версія 0.9.1

* Виправлено проблеми з великими додатками.

У цій версії реалізовано новий спосіб завантаження та збереження файлів додатків.

Тепер у додатках, розмір яких перевищує 20 МБ, не відображатиметься розмір завантаженого файлу, а буде видаватися повідомлення про великий розмір додатка.

Ви зможете відстежувати відсоток завантаження великого додатка завдяки індикатору виконання.

Це має вирішити проблеми, які виникали у деяких користувачів при оновленні або завантаженні великих додатків, коли вони отримували помилки, або NVDA виходила з ладу чи перезапускалась.

Це стосується як окремих завантажень додатків, так і тих, які завантажуються в процесі оновлення вже встановлених додатків.

## Версія 0.9

* Додано підтримку API 2023

## Версія 0.8.5

* Виправлено проблеми, пов’язані з недобросовісною поведінкою розробників, які не дотримуються явних стандартів.

Наприклад:

minimumNVDAVersion = None (ДУЖЕ ПОГАНО) це нічого не коштує, просто 2019.3.0 – це лише 8 бісових символів.